--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/cnc1900_video.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/cnc1900_video.c	2014-08-28 10:34:39.797376000 +0800
@@ -0,0 +1,1234 @@
+/****************************************************************************
+  * [RELEASE HISTORY]
+  * VERSION  DATE       AUTHOR                  DESCRIPTION
+  * 0.1      13-04-16       Jia Ma           		Original
+  ****************************************************************************
+*/
+
+#include <linux/device.h>
+#include <linux/types.h>
+#include <linux/fs.h>
+#include <linux/delay.h>
+#include <linux/miscdevice.h>
+#include <linux/proc_fs.h>
+#include <linux/delay.h>
+#include <linux/firmware.h>
+#include <linux/platform_device.h>
+#include <linux/interrupt.h>
+#include <linux/poll.h>
+#include <linux/sched.h>
+#include <linux/module.h>
+#include <asm/io.h>
+#include <asm/uaccess.h>
+
+#include <mach/mem_define.h>
+#include <mach/cnc1900_power_clk.h>
+#include <mach/cnc1900_df.h>
+#include <mach/cnc1900_vpp_reg_def.h>
+//#include "../xport/xport_drv1800.h"
+#include "video_reg_def.h"
+#include "cnc1900_video.h"
+#include "video_handshake_def.h"
+#include "../xport/xport_drv1900.h"
+
+#ifdef CONFIG_SW_SUPPORT
+#include <mach/smc.h>
+#endif
+
+#ifdef CONFIG_CELESTIAL_VIDEO_DEBUG
+#define DEBUG_PRINT  printk
+#else
+#define DEBUG_PRINT(fmt,args...)
+#endif
+
+//#define IRQ_DEBUG
+
+union _irq_flags {
+    struct {
+        unsigned int picture_ready_enable:1;
+        unsigned int picture_ready:1;
+
+        unsigned int av_sync_enable:1;
+        unsigned int av_sync:1;
+
+        unsigned int enc_frame_done_enable:1;
+        unsigned int enc_frame_done:1;
+
+        unsigned int yuv_frame_done_enable:1;
+        unsigned int yuv_frame_done:1;
+
+        unsigned int yuv_buf_info_done_enable:1;
+        unsigned int yuv_buf_info_done:1;
+
+        unsigned int dec_seq_change_enable:1;
+        unsigned int dec_seq_change:1;
+
+        unsigned int reserved:20;
+    }bits;
+    unsigned int val;
+};
+
+typedef enum _UART_ID_
+{
+	_uart_0 	=0,
+	_uart_1		=1,
+	_uart_2		=2,
+	_uart_audio	=3,
+	_uart_video	=4,
+}UART_ID;
+
+typedef enum _I2C_ID_
+{
+	_i2c_0      =0,
+	_i2c_1      =1,
+}I2C_ID;
+
+typedef enum
+{
+    CHANGE_TG_REQUEST=0,
+    CHANGE_TG_GRANT,
+    CHANGE_TG_FINISH
+}ChangeTgT;
+
+typedef enum{
+    CODA_CLOCK_INDEX_0,//default 270/340
+    CODA_CLOCK_INDEX_1,//290/290
+    CODA_CLOCK_INDEX_2 //300/300
+}CODA_CLOCK_t;
+
+typedef struct CNC1900_video_DEV_t {
+	int instance_num; //instance numbers in the process 
+} cnc1900_video_dev;
+
+#ifndef CONFIG_SW_SUPPORT
+#define video_int_write(v,a)    	do { *(vidint_base + (a)) = (v) ;udelay(10);}while(0)
+#define video_int_read(a)       	*(vidint_base + (a))
+#else
+void video_int_write(unsigned int val, unsigned int a){
+	a = (a)&0xfffff; 
+	sw_smc(SMC_CMD_VIDEO_WIRTE_IRQ_REG, a, val, 0x0);
+}
+
+unsigned int video_int_read(unsigned int a){
+	a = (a)&0xfffff;
+	return sw_smc(SMC_CMD_VIDEO_READ_IRQ_REG, a, 0x0, 0x0);
+}
+#endif
+
+#ifndef CONFIG_SW_SUPPORT
+#define video_write(v,a)    	do { *(csm_video_base + (a)) = (v) ;udelay(10);}while(0)
+#define video_read(a)       	*(csm_video_base + (a))
+#else
+void video_write(unsigned int val, unsigned int a){
+	a = (a)&0xfffff; 
+	sw_smc(SMC_CMD_VIDEO_WIRTE_REG, a, val, 0x0);
+}
+
+unsigned int video_read(unsigned int a){
+	a = (a)&0xfffff;
+	return sw_smc(SMC_CMD_VIDEO_READ_REG, a, 0x0, 0x0);
+}
+#endif
+
+#define REG_SET_BIT(reg, mask) {unsigned int t = __video_read(reg); t |= (mask); __video_write(reg, t);}
+#define REG_CLEAR_BIT(reg, mask) {unsigned int t = __video_read(reg); t &= ~(mask); __video_write(reg, t);}
+
+#define SET_UPDATE_FLAG(reg, updateFlag, cmdType) __video_write(reg, (updateFlag)|(cmdType))
+#define CLEAR_UPDATE_FLAG(reg) __video_write(reg, 0)
+
+
+extern int pinmux_enable_i2c(I2C_ID I2C);
+extern int pinmux_enable_vib(void);
+extern int pinmux_enable_uart(UART_ID UART);
+
+extern void clock_coda_reset(CLOCK_RESET ResetOrSet);
+
+extern void DF_Write(unsigned int addr, unsigned int data);
+extern unsigned int DF_Read(unsigned int addr);
+
+static int __csm_video_release_firmware(void);
+#ifndef CONFIG_SW_SUPPORT
+static void __kernel_load_firmware(int load_coda_flag);
+#endif
+static int __video_init(int load_coda_flag);
+
+DEFINE_SPINLOCK(csm_video_lock);
+DEFINE_SPINLOCK(notify_lock);
+DECLARE_WAIT_QUEUE_HEAD(notify_queue);
+
+DdrFwAttrT* host2videofw_if = NULL;
+
+
+extern int __Is_hd2sd;
+
+static int fw_initialized;
+static int process_num = 0;
+//static int fix_bug_av_sync = 0;
+static union _irq_flags  irq_flags;
+
+static volatile unsigned int *vidmcu_base = NULL;
+#ifndef CONFIG_SW_SUPPORT
+static volatile unsigned int *csm_video_base = NULL;
+static volatile unsigned int *vidint_base = NULL;
+#endif
+
+static struct platform_device *video_pdev;
+#ifndef CONFIG_SW_SUPPORT
+static const struct firmware* video_data_fw=(struct firmware*)NULL;
+static const struct firmware* video_text_fw=(struct firmware*)NULL;
+static const struct firmware* video_coda_fw=(struct firmware*)NULL;
+#endif
+static int csm_video_open(struct inode *inode, struct file *file);
+static int csm_video_release(struct inode *inode, struct file *file);
+static long csm_video_ioctl(struct file *file,unsigned int cmd, unsigned long arg);
+static unsigned int csm_video_poll(struct file *filp, poll_table * wait);
+irqreturn_t csm_vid_irq(int irq, void *dev_id);
+static int csm_video_proc_write(struct file *file, const char *buffer, unsigned long count, void *data);
+
+static struct class *csm_video_class;
+static struct proc_dir_entry *csm_video_proc_entry = NULL;
+static struct file_operations csm_video_fops = {
+	.owner	= THIS_MODULE,
+	.open	=  csm_video_open,
+	.release	= csm_video_release,
+	.unlocked_ioctl	= csm_video_ioctl,
+	.poll		= csm_video_poll,
+};
+
+#ifndef CONFIG_SW_SUPPORT
+unsigned int  __video_write(unsigned int addr, unsigned int val)
+{
+	video_write(val,((addr-CNC_VIDEO_REG_BASE)>>2));
+	return video_read((addr-CNC_VIDEO_REG_BASE)>>2);
+}
+
+unsigned int __video_read(unsigned int addr)
+{
+	return video_read((addr-CNC_VIDEO_REG_BASE)>>2);
+}
+
+#else
+void __video_write(unsigned int a, unsigned int val){
+	a = (a)&0xfffff; 
+	sw_smc(SMC_CMD_VIDEO_WIRTE_REG, a, val, 0x0);
+}
+
+unsigned int __video_read(unsigned int a){
+	a = (a)&0xfffff;
+	return sw_smc(SMC_CMD_VIDEO_READ_REG, a, 0x0, 0x0);
+}
+#endif
+void __HostSendCmd(unsigned int Cmd, UpdateCmdType CmdType, unsigned int Param1, unsigned int Param2)
+{
+	int wait_times = 10;
+
+	while (__video_read(MAILBOX_CMD_UPDATE_FLAG) & BIT_UPDATE_FLAG){
+		wait_times--;
+		mdelay(10);
+		if (wait_times <= 0){
+            break;
+		}
+	}
+
+	switch(CmdType){
+		case UPDATE_PLAY_CMD:
+		{
+			__video_write(MAILBOX_CMD_UPDATE_MSG, Cmd);
+			break;
+		}
+		case UPDATE_REC_CMD:
+		{
+			__video_write(MAILBOX_CMD_UPDATE_MSG, Cmd);
+			break;
+		}
+		case UPDATE_DEBUG_CMD:
+		{
+			__video_write(MAILBOX_CMD_UPDATE_MSG, Cmd);
+			__video_write(MAILBOX_CMD_DEBUG_PARAM1, Param1);
+			__video_write(MAILBOX_CMD_DEBUG_PARAM2, Param2);
+			break;
+		}
+		case UPDATE_TG_CHG_CMD:
+		{
+			__video_write(MAILBOX_CMD_UPDATE_MSG, Cmd);
+			break;
+		}
+		case UPDATE_CODA_RESET_CMD:
+		{
+			__video_write(MAILBOX_CMD_UPDATE_MSG, Cmd);
+			break;
+		}
+		default:
+			return;
+	}
+
+	SET_UPDATE_FLAG(MAILBOX_CMD_UPDATE_FLAG, BIT_UPDATE_FLAG, CmdType);
+	wait_times = 10;
+	while (__video_read(MAILBOX_CMD_UPDATE_FLAG) & BIT_UPDATE_FLAG){
+		wait_times--;
+		mdelay(10);
+		if (wait_times <= 0){
+            break;
+		}
+	}
+
+	return;
+}
+int __video_tve_2_tg(int layer)
+{
+	int buf_num = 0;
+
+	if(0 == layer)
+		buf_num = BUF_TG1;
+	if(1 == layer)
+		buf_num = BUF_TG2;
+
+	return buf_num;
+}
+
+int __change_tg_request(unsigned int TgId)
+{
+    unsigned int Cmd = ((CHANGE_TG_REQUEST&0xf)<<4)|(TgId&0xf);
+
+    __HostSendCmd(Cmd, UPDATE_TG_CHG_CMD, 0, 0);
+
+    return 0;
+}
+
+int __change_tg_release(unsigned int TgId)
+{
+    unsigned int Cmd = ((CHANGE_TG_FINISH&0xf)<<4)|(TgId&0xf);
+
+    __HostSendCmd(Cmd, UPDATE_TG_CHG_CMD, 0, 0);
+    return 0;
+}
+
+void __video_set_layer_position(int layer, unsigned int w, unsigned int h, unsigned int is_interlace, unsigned int frame_rate)
+{
+     host2videofw_if->VppBufAttr[layer].PicFormat.PicWidth = w;
+     host2videofw_if->VppBufAttr[layer].PicFormat.PicHeight = h;
+     host2videofw_if->VppBufAttr[layer].PicFormat.IsInterlace = is_interlace;
+     host2videofw_if->VppBufAttr[layer].PicFormat.FrameRate = frame_rate;
+}
+
+void __video_set_hd2sd(unsigned int tg1_width, unsigned int tg1_height, unsigned int tg2_width, unsigned int tg2_height)
+{
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].En= 1;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].HwSel= LAYER_HWSEL_CAP;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].F2fOrder= 0;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].SrcBufNo= BUF_TG1;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].DesBufNo= BUF_CAP;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Src.StartX= 0;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Src.EndX= tg1_width;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Src.StartY= 0;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Src.EndY= tg1_height;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Des.StartX= 0;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Des.EndX= tg2_width;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Des.StartY= 0;
+     host2videofw_if->VppWinAttr[WIN_D2F_CAP].Des.EndY= tg2_height;
+
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.Format3D = FORMAT_2D;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.FrameRate = 30;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.HorSample = 1;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.VerSample = 0;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.IsInterlace = host2videofw_if->VppBufAttr[BUF_TG1].PicFormat.IsInterlace;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.PicWidth = tg2_width;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.PicHeight = tg2_height;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.TopFieldFirst = 1;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.VactSpace1 = 0;
+     host2videofw_if->VppBufAttr[BUF_CAP].PicFormat.VactSpace2 = 0;
+
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].En= 1;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].HwSel= LAYER_HWSEL_RD2;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].F2fOrder= 0;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].SrcBufNo= BUF_CAP;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].DesBufNo= BUF_TG2;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Src.StartX= 0;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Src.EndX= tg2_width;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Src.StartY= 0;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Src.EndY= tg2_height;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Des.StartX= 0;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Des.EndX= tg2_width;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Des.StartY= 0;
+     host2videofw_if->VppWinAttr[WIN_F2D_RD2].Des.EndY= tg2_height;
+
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.Format3D = FORMAT_2D;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.FrameRate = 3000;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.HorSample = 0;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.VerSample = 0;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.IsInterlace = 1;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.PicWidth = tg2_width;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.PicHeight = tg2_height;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.TopFieldFirst = 1;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.VactSpace1 = 0;
+     host2videofw_if->VppBufAttr[BUF_TG2].PicFormat.VactSpace2 = 0;
+}
+
+void __video_send_hd2sd_cmd(int cmd)
+{
+	unsigned int  Cmd = 1;
+    
+    Cmd |= CH_CAP0 << 24;
+    __HostSendCmd(Cmd, UPDATE_PLAY_CMD, 0, 0);
+}
+
+
+static int csm_video_proc_write(struct file *file, const char *buffer, unsigned long count, void *data)
+{
+	const char *cmd_line = buffer;;
+
+	if (strncmp("rl", cmd_line, 2) == 0) {
+		int addr;
+		addr = simple_strtol(&buffer[3], NULL, 16);
+		printk(" addr[0x%08x] = 0x%08x \n", addr, video_read(addr));
+	}else if((strncmp("dumpreg",cmd_line,7) == 0)){
+	    printk("MAILBOX_FW_ATTR_UPDATE_FLAG   addr:0x%x = 0x%x\n", (MAILBOX_FW_ATTR_UPDATE_FLAG  ) , __video_read(MAILBOX_FW_ATTR_UPDATE_FLAG  ));
+	    printk("MAILBOX_FIRMWARE_CONFIG_BADDR addr:0x%x = 0x%x\n", (MAILBOX_FIRMWARE_CONFIG_BADDR) , __video_read(MAILBOX_FIRMWARE_CONFIG_BADDR));
+	    printk("MAILBOX_DEC_CPB_WPRP_BADDR    addr:0x%x = 0x%x\n", (MAILBOX_DEC_CPB_WPRP_BADDR   ) , __video_read(MAILBOX_DEC_CPB_WPRP_BADDR   ));
+	    printk("MAILBOX_ENC_CPB_WPRP_BADDR    addr:0x%x = 0x%x\n", (MAILBOX_ENC_CPB_WPRP_BADDR   ) , __video_read(MAILBOX_ENC_CPB_WPRP_BADDR   ));
+	    printk("MAILBOX_CODAFW_CONFIG_BADDR   addr:0x%x = 0x%x\n", (MAILBOX_CODAFW_CONFIG_BADDR  ) , __video_read(MAILBOX_CODAFW_CONFIG_BADDR  ));
+	    printk("MAILBOX_CMD_UPDATE_FLAG       addr:0x%x = 0x%x\n", (MAILBOX_CMD_UPDATE_FLAG      ) , __video_read(MAILBOX_CMD_UPDATE_FLAG      ));
+	    printk("MAILBOX_CMD_UPDATE_MSG        addr:0x%x = 0x%x\n", (MAILBOX_CMD_UPDATE_MSG       ) , __video_read(MAILBOX_CMD_UPDATE_MSG       ));
+	    printk("MAILBOX_INT_MSG_UPDATE_FLAG   addr:0x%x = 0x%x\n", (MAILBOX_INT_MSG_UPDATE_FLAG  ) , __video_read(MAILBOX_INT_MSG_UPDATE_FLAG  ));
+	    printk("MAILBOX_DEBUG_CMD_UPDATE_FLAG addr:0x%x = 0x%x\n", (MAILBOX_DEBUG_CMD_UPDATE_FLAG) , __video_read(MAILBOX_DEBUG_CMD_UPDATE_FLAG));
+	    printk("MAILBOX_DEBUG_CMD_UPDATE_MSG  addr:0x%x = 0x%x\n", (MAILBOX_DEBUG_CMD_UPDATE_MSG ) , __video_read(MAILBOX_DEBUG_CMD_UPDATE_MSG ));
+	    printk("MAILBOX_CMD_DEBUG_PARAM1      addr:0x%x = 0x%x\n", (MAILBOX_CMD_DEBUG_PARAM1     ) , __video_read(MAILBOX_CMD_DEBUG_PARAM1     ));
+	    printk("MAILBOX_CMD_DEBUG_PARAM2      addr:0x%x = 0x%x\n", (MAILBOX_CMD_DEBUG_PARAM2     ) , __video_read(MAILBOX_CMD_DEBUG_PARAM2     ));
+	    printk("MAILBOX_FIRMWARE_VERSION      addr:0x%x = 0x%x\n", (MAILBOX_FIRMWARE_VERSION    ) , __video_read(MAILBOX_FIRMWARE_VERSION     ));
+	    printk("MAILBOX_CODA_VERSION          addr:0x%x = 0x%x\n", (MAILBOX_CODA_VERSION        ) , __video_read(MAILBOX_CODA_VERSION         ));
+	    printk("MAILBOX_MIPS_DEBUG_FEEDBACK1  addr:0x%x = 0x%x\n", (MAILBOX_MIPS_DEBUG_FEEDBACK1) , __video_read(MAILBOX_MIPS_DEBUG_FEEDBACK1 ));
+	    printk("MAILBOX_MIPS_DEBUG_FEEDBACK2  addr:0x%x = 0x%x\n", (MAILBOX_MIPS_DEBUG_FEEDBACK2) , __video_read(MAILBOX_MIPS_DEBUG_FEEDBACK2 ));
+	    printk("MAILBOX_FW_LOG_BADDR          addr:0x%x = 0x%x\n", (MAILBOX_FW_LOG_BADDR        ) , __video_read(MAILBOX_FW_LOG_BADDR         ));
+	    printk("MAILBOX_FW_LOG_UPDATE_FLAG    addr:0x%x = 0x%x\n", (MAILBOX_FW_LOG_UPDATE_FLAG  ) , __video_read(MAILBOX_FW_LOG_UPDATE_FLAG   ));
+	    printk("MAILBOX_INT_TYPE              addr:0x%x = 0x%x\n", (MAILBOX_INT_TYPE            ) , __video_read(MAILBOX_INT_TYPE             ));
+	    printk("MAILBOX_VIDEO_PTS             addr:0x%x = 0x%x\n", (MAILBOX_VIDEO_PTS           ) , __video_read(MAILBOX_VIDEO_PTS            ));
+	    printk("MAILBOX_STATIC_BUF_ADDR       addr:0x%x = 0x%x\n", (MAILBOX_STATIC_BUF_ADDR   	) , __video_read(MAILBOX_STATIC_BUF_ADDR   	));
+	    printk("MAILBOX_PIC_MEM_SIZE          addr:0x%x = 0x%x\n", (MAILBOX_PIC_MEM_SIZE   		) , __video_read(MAILBOX_PIC_MEM_SIZE   		));
+	    printk("MAILBOX_MIPS_TIME             addr:0x%x = 0x%x\n", (MAILBOX_MIPS_TIME           ) , __video_read(MAILBOX_MIPS_TIME            ));
+	    printk("MAILBOX_MIPS_HEART_BEAT       addr:0x%x = 0x%x\n", (MAILBOX_MIPS_HEART_BEAT     ) , __video_read(MAILBOX_MIPS_HEART_BEAT      ));
+
+	    printk("INT_RISCCPU_EN                addr:0x%x = 0x%x\n", (INT_RISCCPU_EN          ), video_int_read(0x00));
+#ifndef CONFIG_SW_SUPPORT
+	    printk("INT_RISCCPU_MASK              addr:0x%x = 0x%x\n", (INT_RISCCPU_MASK        ), video_int_read(0x08>>2));
+	    printk("INT_RISCCPU_FORCE             addr:0x%x = 0x%x\n", (INT_RISCCPU_FORCE       ), video_int_read(0x10>>2));
+	    printk("INT_RISCCPU_FINALSTATUS       addr:0x%x = 0x%x\n", (INT_RISCCPU_FINALSTATUS ), video_int_read(0x30>>2));
+	    printk("INT_COPSW_EN                  addr:0x%x = 0x%x\n", (INT_COPSW_EN            ), video_int_read(0xc0>>2));
+	    printk("INT_COPSW_MASK                addr:0x%x = 0x%x\n", (INT_COPSW_MASK          ), video_int_read(0xc4>>2));
+	    printk("INT_COPSW_FORCE               addr:0x%x = 0x%x\n", (INT_COPSW_FORCE         ), video_int_read(0xc8>>2));
+	    printk("INT_COPSW_FINALSTATUS         addr:0x%x = 0x%x\n", (INT_COPSW_FINALSTATUS   ), video_int_read(0xd4>>2));
+#else
+	    printk("INT_RISCCPU_MASK              addr:0x%x = 0x%x\n", (INT_RISCCPU_MASK        ), video_int_read(0x08));
+	    printk("INT_RISCCPU_FORCE             addr:0x%x = 0x%x\n", (INT_RISCCPU_FORCE       ), video_int_read(0x10));
+	    printk("INT_RISCCPU_FINALSTATUS       addr:0x%x = 0x%x\n", (INT_RISCCPU_FINALSTATUS ), video_int_read(0x30));
+	    printk("INT_COPSW_EN                  addr:0x%x = 0x%x\n", (INT_COPSW_EN            ), video_int_read(0xc0));
+	    printk("INT_COPSW_MASK                addr:0x%x = 0x%x\n", (INT_COPSW_MASK          ), video_int_read(0xc4));
+	    printk("INT_COPSW_FORCE               addr:0x%x = 0x%x\n", (INT_COPSW_FORCE         ), video_int_read(0xc8));
+	    printk("INT_COPSW_FINALSTATUS         addr:0x%x = 0x%x\n", (INT_COPSW_FINALSTATUS   ), video_int_read(0xd4));
+#endif
+	}
+
+	return count;
+}
+
+#ifndef CONFIG_SW_SUPPORT
+static int __video_firmware_to_mips(int load_coda_flag)
+{
+	size_t firmware_size_txt = 0, firmware_size_dat = 0;
+	unsigned int *p_src = NULL,*p_src_dat = NULL;
+	volatile unsigned int *p_buf = NULL,*p_buf_dat = NULL;
+	volatile unsigned int *start_addr = NULL;
+	unsigned int i = 0;
+
+	if (video_text_fw!=(struct firmware*)NULL){
+		firmware_size_txt= video_text_fw->size>>2;
+		p_src= (unsigned int *)video_text_fw->data;
+		firmware_size_dat = (video_data_fw->size)>>2;
+		p_src_dat= (unsigned int *)video_data_fw->data;
+	}
+
+	if(p_src!=NULL){
+		start_addr = (volatile unsigned int *) vidmcu_base;
+		memset((char *)start_addr, 0,VIDEO_MCU_SIZE);
+		for (i = INST_OUT_MEM_SIZE / sizeof(unsigned int); i < firmware_size_txt; i++)
+			*start_addr++ = p_src[i];
+		for (i = 0; i < 4; i++)
+			*start_addr++ = 0;
+
+		p_buf = csm_video_base + MIPS_ISRAM_OFFSET;
+		memset((char *)p_buf, 0,MIPS_ISRAM_MEM_SIZE);
+		if (firmware_size_txt > (MIPS_ISRAM_MEM_SIZE) / sizeof(unsigned int))
+			firmware_size_txt = (MIPS_ISRAM_MEM_SIZE) / sizeof(unsigned int);
+
+		for (i = 0; i < firmware_size_txt; i++)
+			p_buf[i] = p_src[i];
+
+		p_buf_dat= csm_video_base + MIPS_DSRAM_OFFSET;
+		memset((char *)p_buf_dat, 0,MIPS_DSRAM_MEM_SIZE);
+		for (i = 0; i < firmware_size_dat; i++)
+		{
+			p_buf_dat[i] = p_src_dat[i];
+		}
+
+		for (; i < MIPS_DSRAM_MEM_SIZE / sizeof(unsigned int); i++)
+			p_buf_dat[i] = 0x0;
+	}
+
+if(0){
+	int i = 0;
+	printk("VIDEO_STUFF_REGION = 0x%x\n",VIDEO_STUFF_REGION);
+	for(i = 0; i<10; i++){
+		printk("0x%08x ",p_src[i]);
+		printk("0x%08x ",*(csm_video_base + MIPS_ISRAM_OFFSET+i));
+	}
+	printk("\n");
+
+	for(i = 0; i < 10;i++){
+		printk("0x%08x ",p_src[i+1024/4]);
+		printk("0x%08x ",*(vidmcu_base+i));
+	}
+	printk("\n");
+}
+	if (load_coda_flag){
+	    	if(video_coda_fw!=(struct firmware*)NULL){
+	    		firmware_size_txt = video_coda_fw->size;
+	    		p_src = (unsigned int *)video_coda_fw->data;
+	    	}
+
+	    	if(p_src!=NULL){
+	    		volatile char *start_addr = NULL;
+	    		volatile char *temp = NULL;
+
+	    		start_addr = (volatile char *)(vidmcu_base + (VIDEO_CODA_OFFSET>>2));
+	    		temp = (volatile char *)p_src;
+
+	    		for (i = 0; i < firmware_size_txt; i++)
+	    		{
+	    			start_addr[i] = temp[i];
+	    		}
+	    	}
+if(0){
+		for(i = 0; i < 10;i++){
+			printk("0x%08x ",p_src[i]);
+			printk("0x%08x ",*(vidmcu_base+(VIDEO_CODA_OFFSET>>2)+i));
+		}
+		printk("\n, firmware_size_txt = 0x%x\n",firmware_size_txt);
+		for(i = (firmware_size_txt>>2); i > ((firmware_size_txt>>2)-10);i--){
+			printk("0x%08x ",p_src[i-1]);
+			printk("0x%08x ",*(vidmcu_base+(VIDEO_CODA_OFFSET>>2)+ i -1));
+		}
+		printk("\n");
+}
+	}
+
+	return 0;
+}
+#endif
+static int __video_init(int load_coda_flag)
+{
+	/* reset mcu */
+	video_write(0xffffffff, MIPS_RESET_OFFSET);
+	udelay(5);
+
+	clock_coda_reset(_do_reset);
+	mdelay(10);
+	clock_coda_reset(_do_set);
+#ifndef CONFIG_SW_SUPPORT
+	__video_firmware_to_mips(load_coda_flag);
+#endif
+	return 0;
+}
+
+#ifndef CONFIG_SW_SUPPORT
+static void __kernel_load_firmware(int load_coda_flag)
+{
+	int ret;
+	if (video_text_fw == NULL) {
+        ret = request_firmware(&video_text_fw, "video_fw_text.bin", &(video_pdev->dev));
+        if (unlikely(ret != 0 || video_text_fw== NULL)) {
+            printk(KERN_ERR "Failed to load video firmware code section 1\n");
+            return;
+        }
+        else{
+            if (unlikely(video_text_fw->size > VIDEO_MCU_SIZE)){
+				release_firmware(video_text_fw);
+				video_text_fw=NULL;
+				printk(KERN_ERR "Failed to load video firmware code section 2\n");
+				return;
+            }
+            if(video_text_fw!=NULL && video_data_fw == NULL){
+                ret = request_firmware(&video_data_fw, "video_fw_data.bin", &(video_pdev->dev));
+                if (unlikely(ret != 0 || video_data_fw== NULL)) {
+                    release_firmware(video_text_fw);
+                    video_text_fw=NULL;
+                    printk(KERN_ERR "Failed to load video firmware data section 1\n");
+                    return;
+                }
+                else{
+                    if (unlikely(video_data_fw->size > MIPS_DSRAM_MEM_SIZE )){
+			    		release_firmware(video_data_fw);
+						video_data_fw=NULL;
+						release_firmware(video_text_fw);
+						video_text_fw=NULL;
+						printk(KERN_ERR "Failed to load video firmware data section 2\n");
+						return;
+                    }
+                }
+            }
+        }
+	}
+
+	if (load_coda_flag){
+	    	if (video_coda_fw == NULL) {
+	            ret = request_firmware(&video_coda_fw, "video_fw_coda.bin", &(video_pdev->dev));
+	            if (unlikely(ret != 0 || video_coda_fw== NULL)) {
+	                printk(KERN_ERR "Failed to load video coda firmware 1\n");
+	                return;
+	            }
+	            else{
+	                if (unlikely(video_coda_fw->size > VIDEO_CODA_SIZE)){
+	    				release_firmware(video_coda_fw);
+	    				video_coda_fw=NULL;
+	    				printk(KERN_ERR "Failed to load video coda firmware 2\n");
+	    				return;
+	                }
+	            }
+	    	}
+	}
+
+	return;
+}
+#endif
+static int __csm_video_release_firmware(void)
+{
+
+#if 0
+	/* stop video */
+	for (ch = 0; ch < MAX_CHANNEL_NUM; ch++){
+		printk("channel %d \n", ch);
+		if (host2videofw_if->channel_num & (1 << ch)){ // current channel enable, send stop cmd
+			i = 0;
+			while (video_read(HOST_CMD_REG) >> 31){ // wait last cmd ack
+				i++;
+				udelay(100);
+
+				if(1000 == i)
+					break;
+			}
+
+			i = 0;
+			cmd = (ch << 24) | 2; // 2: send stop cmd
+			video_write(cmd|0x80000000, HOST_CMD_REG);
+
+			do{
+				if((video_read(HOST_CMD_REG) >> 31) == 0x0)
+					break;
+
+				udelay(100);
+				i++;
+
+				//printk("CNC VIDEO release failed %d!\n", i);
+
+				if (1000 == i)
+					break;
+			}while(1);
+
+			printk("CNC VIDEO %d release success!\n", ch);
+		}
+	}
+
+	// close interrupt
+	reg = *(vidint_base + VID_RISC_ENA);
+	//    printk("HOST_INT_ENABLE = 0x%08x\n", reg);
+	reg |= (1 << 31);
+	*(vidint_base + VID_RISC_ENA) = reg;
+	//    printk("HOST_INT_ENABLE = 0x%08x\n", reg);
+	*(vidint_base + VID_RISC_INT) = (1 << 31);
+
+	i = 0;
+	do{
+		reg = *(vidint_base + VID_RISC_INT);
+		//        printk("HOST_INT_FORCE = 0x%08x\n", reg);
+		if(video_read(0x3d) == 0x1004e)
+			break;
+
+		i++;
+		if(1000 == i)
+			break;
+
+		udelay(100);
+
+	}while (1);
+#endif
+
+	/* reset mcu */
+	video_write(0xffffffff, MIPS_RESET_OFFSET);
+
+#ifndef CONFIG_SW_SUPPORT
+	if (video_text_fw != NULL ){
+		release_firmware(video_text_fw);
+		video_text_fw = NULL;
+	}
+	if (video_data_fw != NULL){
+		release_firmware(video_data_fw);
+		video_data_fw = NULL;
+	}
+	if (video_coda_fw != NULL) {
+		release_firmware(video_coda_fw);
+		video_coda_fw = NULL;
+	}
+#endif
+	// coda reset
+//	printk("start code clock reset!\n");
+//	clock_coda_reset(_do_reset);
+//	printk("reset code step 1 done\n");
+//	clock_coda_reset(_do_set);
+//	printk("reset step 2 done\n");
+
+	//video_write(0xf, 0x15C>>2);//video clock disable
+//	clock_video_clockena(_clock_disable);
+//	clock_vib_clockena(_clock_disable);
+//	clock_coda_clockena(_clock_disable);
+
+	return 0;
+}
+
+static int csm_video_open(struct inode *inode, struct file *file)
+{
+	volatile char *start_addr = (volatile char *)vidmcu_base;
+    cnc1900_video_dev *cnc1900_video = NULL;
+
+	printk("CNC VIDEO has been opened\n");
+	printk("CNC VIDEO sizeof(DdrFwAttrT) = %d\n",sizeof(DdrFwAttrT));
+
+    if(NULL == file->private_data){
+
+        cnc1900_video = kmalloc(sizeof(cnc1900_video_dev), GFP_KERNEL); 
+        if(NULL == cnc1900_video){
+            printk("Cant't open video device\n"); 
+            return -EBUSY;
+        } 
+
+        process_num++;
+        cnc1900_video->instance_num = 1;
+
+        if(0 == fw_initialized){
+	        request_irq(VIDEO_IRQ, csm_vid_irq, 0, "cnc_video_irq", NULL);
+
+            printk("CNC VIDEO load video firmware ...\n");
+            irq_flags.val = 0;
+            irq_flags.bits.picture_ready_enable = 1;
+            irq_flags.bits.av_sync_enable       = 1;
+            //irq_flags.bits.yuv_frame_done_enable = 1;
+
+#ifndef CONFIG_SW_SUPPORT
+            video_int_write(0x1, INT_COPSW_EN_OFFSET>>2);
+            video_int_write(0x0, INT_COPSW_MASK_OFFSET>>2);
+            video_int_write(0x0, INT_COPSW_FORCE_OFFSET>>2);
+            __kernel_load_firmware(1);
+#else
+            video_int_write(0x1, INT_COPSW_EN_OFFSET);
+            video_int_write(0x0, INT_COPSW_MASK_OFFSET);
+            video_int_write(0x0, INT_COPSW_FORCE_OFFSET);
+#endif
+            memset((char *)start_addr,0x0,VIDEO_STUFF_SIZE);
+            __video_init(1);
+
+            fw_initialized = 1;
+        }
+        file->private_data = cnc1900_video;
+    }else{
+        cnc1900_video->instance_num++;
+    }
+	return 0;
+}
+
+
+static int csm_video_release(struct inode *inode, struct file *file)
+{
+    cnc1900_video_dev *cnc1900_video = NULL;
+    
+    if(file->private_data){ 
+
+        cnc1900_video = file->private_data;
+        cnc1900_video->instance_num--;
+     
+        if(cnc1900_video->instance_num > 0){
+
+        }else{
+            process_num--;
+            kfree(cnc1900_video);
+            file->private_data = NULL;
+
+            if(process_num <= 0){
+                if(fw_initialized){
+                    fw_initialized = 0;
+                    __csm_video_release_firmware();
+	                printk("CNC VIDEO release video firmware ...\n");
+                }
+            }
+        }
+        return 0;
+    }else{
+        //printk("Multi-times release video firmware don't again\n");
+        return -1;
+    }
+}
+static long csm_video_ioctl(struct file *file,unsigned int cmd, unsigned long arg)
+{
+	unsigned long flags;
+
+	switch (cmd){
+		case CSVID_IOC_GET_VIDEO_TO_HOST_MSG_SIZE:
+			__put_user(VIDEO_VIDEO_TO_HOST_MSG_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_TO_HOST_MSG_ADDR:
+			__put_user(VIDEO_VIDEO_TO_HOST_MSG_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_HOST_TO_VIDEO_MSG_SIZE:
+			__put_user(VIDEO_HOST_TO_VIDEO_MSG_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_HOST_TO_VIDEO_MSG_ADDR:
+			__put_user(VIDEO_HOST_TO_VIDEO_MSG_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_DPB_SIZE:
+			__put_user(VIDEO_DPB_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_DPB_ADDR:
+			__put_user(VIDEO_DPB_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_CODA_ADDR:
+			__put_user(VIDEO_CODA_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_NUM:
+			__put_user(VIDEO_NUM, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_CPB_ADDR:
+			__put_user(VIDEO_CPB_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_CPB_SIZE:
+			__put_user(VIDEO_CPB_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_CPB_DIR_ADDR:
+			__put_user(VIDEO_CPB_DIR_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_CPB_DIR_SIZE:
+			__put_user(VIDEO_CPB_DIR_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_ENC_NUM:
+			__put_user(VIDEO_ENC_NUM, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_ENC_CPB_ADDR:
+			__put_user(VIDEO_ENC_CPB_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_ENC_CPB_SIZE:
+			__put_user(VIDEO_ENC_CPB_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_ENC_DIR_ADDR:
+			__put_user(VIDEO_ENC_DIR_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_ENC_DIR_SIZE:
+			__put_user(VIDEO_ENC_DIR_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_HOST_IF_ADDR:
+			__put_user(VIDEO_HOST_IF_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_HOST_IF_SIZE:
+			__put_user(VIDEO_HOST_IF_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_REG_ADDR:
+			__put_user(CNC_VIDEO_REG_BASE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_REG_SIZE:
+			__put_user(CNC_VIDEO_REG_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_XPORT_SIZE:
+			__put_user(XPORT_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_XPORT_WPRP_ADDR:
+			__put_user(MIPS_EXTERNAL_BASE_ADDR, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_XPORT_WPRP_SIZE:
+			__put_user(MIPS_EXTERNAL_SIZE, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_UD_ADDR:
+			__put_user(VIDEO_USER_DATA_REGION, (unsigned int __user *) arg);
+			break;
+		case CSVID_IOC_GET_VIDEO_UD_SIZE:
+			__put_user(VIDEO_USER_DATA_SIZE, (unsigned int __user *) arg);
+			break;
+        case CSVID_IOC_GET_HD2SD_MODE:
+            __put_user(__Is_hd2sd, (unsigned int __user *)arg);
+            break;
+        case CSVID_IOC_GET_VIDEO_CODA_CLOCK:
+			__put_user(CONFIG_VIDEO_CODA_CLOCK, (unsigned int __user *) arg);
+			break;
+        case CSVID_IOC_SET_VIDEO_ALPHA:
+        {
+            union{
+                struct{
+                    unsigned int blending2_alpha1:10;
+                    unsigned int reserved_1:6;
+                    unsigned int blending2_alpha2:10;
+                    unsigned int reserved_2:6;
+                }bits;
+                unsigned int val;
+            }b2_alpha;
+
+            b2_alpha.val = 0;
+            b2_alpha.bits.blending2_alpha1 = (unsigned int)arg & 0x3ff; 
+            b2_alpha.bits.blending2_alpha2 = (unsigned int)arg & 0x3ff; 
+
+            DF_Write(VPP_REG_COMP_B2_DEFAULT_ALPHA, b2_alpha.val);
+            break;
+        }
+        case CSVID_IOC_GET_VIDEO_ALPHA:
+        {
+            union{
+                struct{
+                    unsigned int blending2_alpha1:10;
+                    unsigned int reserved_1:6;
+                    unsigned int blending2_alpha2:10;
+                    unsigned int reserved_2:6;
+                }bits;
+                unsigned int val;
+            }b2_alpha;
+            b2_alpha.val = 0;
+            b2_alpha.val = DF_Read(VPP_REG_COMP_B2_DEFAULT_ALPHA);
+            __put_user(b2_alpha.bits.blending2_alpha1, (unsigned int __user*)arg);
+            break;
+        }
+        case CSVID_IOC_GET_TG1_PIC_FORMAT:
+        { 
+            if(copy_to_user((void*)arg, (void*)&host2videofw_if->VppBufAttr[BUF_TG1].PicFormat, sizeof(PicFormatT))){
+                return -EFAULT;
+            }
+            break; 
+        }
+		case CSVID_IOC_SET_VIDEO_START:
+//			printk("mips start\n");
+			video_write(VIDEO_MCU_REGION >> 3, MIPS_RESET_OFFSET);
+			break;
+
+		case CSVID_IOC_GET_NOTIFY_TYPE:
+		{
+			int tempval = 0;
+#ifdef IRQ_DEBUG
+			printk("\n--CSVID_IOC_GET_NOTIFY_TYPE-- flags:0x%x\n", irq_flags.val);
+#endif
+            spin_lock_irqsave(&notify_lock, flags);
+            if(irq_flags.bits.picture_ready_enable && irq_flags.bits.picture_ready){
+                tempval |= VID_INT_DEC_PIC_READY;
+                irq_flags.bits.picture_ready = 0;
+            }
+            if(irq_flags.bits.av_sync_enable && irq_flags.bits.av_sync){
+                tempval |= VID_INT_AV_SYNC_OK;
+                irq_flags.bits.av_sync = 0;
+            } 
+            if(irq_flags.bits.enc_frame_done_enable && irq_flags.bits.enc_frame_done){
+
+                tempval |= VID_INT_ENC_FRAME_DONE;
+                irq_flags.bits.enc_frame_done = 0;
+            } 
+            if(irq_flags.bits.yuv_frame_done_enable && irq_flags.bits.yuv_frame_done){
+
+                tempval |= VID_INT_FRAME_OUTPUT;
+                irq_flags.bits.yuv_frame_done = 0;
+            } 
+            if(irq_flags.bits.yuv_buf_info_done_enable && irq_flags.bits.yuv_buf_info_done){
+
+                tempval |= VID_INT_YUV_BUF_INFO;
+                irq_flags.bits.yuv_buf_info_done = 0;
+            } 
+            if(irq_flags.bits.dec_seq_change_enable && irq_flags.bits.dec_seq_change){
+
+                tempval |= VID_INT_DEC_SEQ_CHANGE;
+                irq_flags.bits.dec_seq_change = 0;
+            } 
+      
+			__put_user(tempval, (unsigned int __user *) arg);
+			spin_unlock_irqrestore(&notify_lock, flags);
+			break;
+		}
+
+		case CSVID_IOC_SET_NOTIFY_TYPE:
+		{
+			int type_val = 0;
+			int enable_bit = 0;
+#ifdef IRQ_DEBUG
+			printk("CSVID_IOC_SET_NOTIFY_TYPE!\n");
+#endif
+            spin_lock_irqsave(&notify_lock, flags);
+            type_val = arg & (~VID_INT_ENABLE);
+            enable_bit = arg>>31;
+#ifdef IRQ_DEBUG
+			printk("type_val = 0x%x, enable_bit = %d\n",type_val,enable_bit);
+#endif
+            if(type_val & VID_INT_DEC_PIC_READY){
+                irq_flags.bits.picture_ready_enable = enable_bit;
+                irq_flags.bits.picture_ready        = 0;
+            }
+            if(type_val & VID_INT_AV_SYNC_OK){
+                irq_flags.bits.av_sync_enable = enable_bit;
+                irq_flags.bits.av_sync        = 0;
+            }
+            if(type_val & VID_INT_ENC_FRAME_DONE){
+                irq_flags.bits.enc_frame_done_enable = enable_bit;
+                irq_flags.bits.enc_frame_done        = 0;
+            }
+            if(type_val & VID_INT_FRAME_OUTPUT){
+                irq_flags.bits.yuv_frame_done_enable = enable_bit;
+                irq_flags.bits.yuv_frame_done        = 0;
+            }
+            if(type_val & VID_INT_YUV_BUF_INFO){
+                irq_flags.bits.yuv_buf_info_done_enable = enable_bit;
+                irq_flags.bits.yuv_buf_info_done        = 0;
+            }
+            if(type_val & VID_INT_DEC_SEQ_CHANGE){
+                irq_flags.bits.dec_seq_change_enable = enable_bit;
+                irq_flags.bits.dec_seq_change        = 0;
+            }
+
+			spin_unlock_irqrestore(&notify_lock, flags);
+			break;
+		}
+
+		case CSVID_IOC_SET_VIB_PINMUX:
+			if(arg == 1){
+				pinmux_enable_i2c(_i2c_0);
+				pinmux_enable_vib();
+			}
+			else{
+				/* need do something here. */
+			}
+
+			clock_vib_reset(0);
+			udelay(10);
+			clock_vib_reset(1);
+			break;
+		case CSVID_IOC_RELOAD_FIRMWARE:
+			//__csm_video_release_firmware();
+			//udelay(100);
+#ifndef CONFIG_SW_SUPPORT
+			__kernel_load_firmware(0);
+#endif
+            //udelay(100);
+			//mdelay(1000);
+			__video_init(0);
+			//udelay(100);
+//			video_write(0x0, HOST_DPB_STATUS);
+//			video_write(0x0, MIPS_DPB_STATUS);
+	//		video_write(VIDEO_HOST_IF_REGION, HOST_IF_VID_MIPS_MAILBOX_0);
+#ifndef CONFIG_SW_SUPPORT
+			video_write(VIDEO_MCU_REGION >> 3, MIPS_RESET_OFFSET);
+#endif
+			//mdelay(10);
+			break;
+
+		default:
+			return -EINVAL;
+	}
+
+	return 0;
+}
+
+static unsigned int csm_video_poll(struct file *filp, poll_table * wait)
+{
+	unsigned int mask = 0;
+
+    if(irq_flags.bits.picture_ready || irq_flags.bits.av_sync || irq_flags.bits.enc_frame_done || irq_flags.bits.yuv_frame_done || irq_flags.bits.yuv_buf_info_done || irq_flags.bits.dec_seq_change){
+		mask = POLLIN | POLLWRNORM;
+		return mask;
+    }
+
+	poll_wait(filp, &notify_queue, wait);
+	return mask;
+}
+
+irqreturn_t csm_vid_irq(int irq, void *dev_id)
+{
+	unsigned long flag;
+	unsigned int irq_reg = 0;
+	unsigned int temp_val = 0;
+	//unsigned int channel_id = 0;
+
+	irq_reg = __video_read(MAILBOX_INT_TYPE);
+
+    if(irq_reg & VID_INT_DEC_PIC_READY){
+#ifdef IRQ_DEBUG
+        printk("csm_vid_irq VID_INT_DEC_PIC_READY\n");
+#endif
+        spin_lock_irqsave(&notify_lock, flag);
+        irq_flags.bits.picture_ready = 1;
+        spin_unlock_irqrestore(&notify_lock, flag);
+
+    }
+    if(irq_reg & VID_INT_AV_SYNC_OK){
+#ifdef IRQ_DEBUG
+        printk("csm_vid_irq VID_INT_AV_SYNC_OK\n");
+#endif
+        spin_lock_irqsave(&notify_lock, flag);
+        irq_flags.bits.av_sync = 1;
+        spin_unlock_irqrestore(&notify_lock, flag);
+    }
+    if(irq_reg & VID_INT_ENC_FRAME_DONE){
+#ifdef IRQ_DEBUG
+        //printk("csm_vid_irq VID_INT_ENC_FRAME_DONE\n");
+#endif
+        spin_lock_irqsave(&notify_lock, flag);
+        irq_flags.bits.enc_frame_done = 1;
+        spin_unlock_irqrestore(&notify_lock, flag);
+    }
+
+    if(irq_reg & VID_INT_FRAME_OUTPUT){
+#ifdef IRQ_DEBUG
+        printk("csm_vid_irq VID_INT_FRAME_OUTPUT\n");
+#endif
+        spin_lock_irqsave(&notify_lock, flag);
+        irq_flags.bits.yuv_frame_done = 1;
+        spin_unlock_irqrestore(&notify_lock, flag);
+    }
+
+    if(irq_reg & VID_INT_YUV_BUF_INFO){
+#ifdef IRQ_DEBUG
+        printk("csm_vid_irq VID_INT_YUV_BUF_INFO\n");
+#endif
+        spin_lock_irqsave(&notify_lock, flag);
+        irq_flags.bits.yuv_buf_info_done = 1;
+        spin_unlock_irqrestore(&notify_lock, flag);
+    }
+
+    if(irq_reg & VID_INT_DEC_SEQ_CHANGE){
+#ifdef IRQ_DEBUG
+        printk("csm_vid_irq VID_INT_DEC_SEQ_CHANGE\n");
+#endif
+        spin_lock_irqsave(&notify_lock, flag);
+        irq_flags.bits.dec_seq_change = 1;
+        spin_unlock_irqrestore(&notify_lock, flag);
+    }
+
+	temp_val = __video_read(MAILBOX_INT_TYPE);
+	temp_val = temp_val^irq_reg;
+	__video_write(MAILBOX_INT_TYPE, temp_val);
+
+#ifndef CONFIG_SW_SUPPORT
+    video_int_write(0, INT_COPSW_FORCE_OFFSET>>2);
+#else
+    video_int_write(0, INT_COPSW_FORCE_OFFSET);
+#endif
+	udelay(10);
+
+	return IRQ_HANDLED;
+}
+
+static void __video_mem_initialize(void)
+{
+#ifndef CONFIG_SW_SUPPORT
+	if (!request_mem_region(CNC_VIDEO_REG_BASE, CNC_VIDEO_REG_SIZE, "CNC1900 Video"))
+		goto ERR_MEM1;
+
+	if (NULL == (csm_video_base = ioremap(CNC_VIDEO_REG_BASE, CNC_VIDEO_REG_SIZE)))
+		goto ERR_MEM2;
+#endif
+	if (!request_mem_region(VIDEO_STUFF_REGION, VIDEO_STUFF_SIZE, "MCU Video"))
+		goto ERR_MEM3;
+
+	if (NULL == (vidmcu_base = ioremap(VIDEO_STUFF_REGION, VIDEO_STUFF_SIZE)))
+		goto ERR_MEM4;
+#ifndef CONFIG_SW_SUPPORT
+	if (!request_mem_region(CNC_INT_REG_BASE, CNC_INT_REG_SIZE, "Video INT"))
+		goto ERR_MEM5;
+
+	if (NULL == (vidint_base = ioremap(CNC_INT_REG_BASE, CNC_INT_REG_SIZE)))
+		goto ERR_MEM6;
+#endif
+	return;
+
+#ifndef CONFIG_SW_SUPPORT
+	ERR_MEM6:
+	release_mem_region(CNC_INT_REG_BASE, CNC_INT_REG_SIZE);
+	ERR_MEM5:
+	iounmap((void *) vidmcu_base);
+	ERR_MEM4:
+	release_mem_region(VIDEO_STUFF_REGION, VIDEO_STUFF_SIZE);
+	ERR_MEM3:
+	iounmap((void *) csm_video_base);
+	ERR_MEM2:
+	release_mem_region(CNC_VIDEO_REG_BASE, CNC_VIDEO_REG_SIZE);
+	ERR_MEM1:
+#else
+	ERR_MEM4:
+	release_mem_region(VIDEO_STUFF_REGION, VIDEO_STUFF_SIZE);
+	ERR_MEM3:
+#endif
+	return;
+}
+static void __video_mem_destroy(void)
+{
+#ifndef CONFIG_SW_SUPPORT
+	iounmap((void *)csm_video_base);
+	release_mem_region(CNC_VIDEO_REG_BASE, CNC_VIDEO_REG_SIZE);
+#endif
+	iounmap((void *)vidmcu_base);
+	release_mem_region(VIDEO_STUFF_REGION, VIDEO_STUFF_SIZE);
+#ifndef CONFIG_SW_SUPPORT
+	iounmap((void *)vidint_base);
+	release_mem_region(CNC_INT_REG_BASE, CNC_INT_REG_SIZE);
+#endif
+}
+
+static int __init cnc_video_init(void)
+{
+	if (register_chrdev(VIDEO_MAJOR, "cnc_1900_video", &csm_video_fops)){
+		printk("cnc_video_init register_chrdev failed.\n");
+		return -ENODEV;
+	}
+
+	video_pdev = platform_device_register_simple("cnc_1900_video", 0, NULL, 0);
+    	if (IS_ERR(video_pdev)) {
+		unregister_chrdev(VIDEO_MAJOR, "cnc_1900_video");
+		printk("cnc_video_init platform_device_register_simple failed.\n");
+        	return -ENODEV;
+    	}
+
+	csm_video_class = class_create(THIS_MODULE,"cnc_1900_video");
+	if (IS_ERR(csm_video_class)){
+		class_destroy(csm_video_class);
+		unregister_chrdev(VIDEO_MAJOR, "cnc_1900_video");
+		printk("cnc_video_init class create failed.\n");
+		csm_video_class = NULL;
+		return -ENODEV;
+	}
+
+	device_create(csm_video_class, NULL, MKDEV(VIDEO_MAJOR, 0), NULL, "cnc_1900_video");
+
+	csm_video_proc_entry = create_proc_entry("cnc_video", 0, NULL);
+	if (NULL != csm_video_proc_entry) {
+		csm_video_proc_entry->write_proc = &csm_video_proc_write;
+	}
+
+	__video_mem_initialize();
+
+	host2videofw_if = (DdrFwAttrT *)(vidmcu_base + (VIDEO_HOST_IF_OFFSET>>2));
+    memset(host2videofw_if, 0, sizeof(DdrFwAttrT));
+	printk("cnc_video_init done.\n");
+	return 0;
+}
+
+static void __exit cnc_video_exit(void)
+{
+	__video_mem_destroy();
+
+	if (NULL != csm_video_proc_entry)
+		remove_proc_entry("cnc_video", NULL);
+
+	device_destroy(csm_video_class,MKDEV(VIDEO_MAJOR, 0));
+	class_destroy(csm_video_class);
+	unregister_chrdev(VIDEO_MAJOR, "cnc_1900_video");
+
+	printk("cnc_video_exit done.\n");
+	return;
+}
+
+module_init(cnc_video_init);
+module_exit(cnc_video_exit);
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/video/cnc1900_video.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/video/cnc1900_video.h
